Attribute VB_Name = "modMF"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2020

Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const CC_STDCALL As Long = &H4&
Public Const IID_Release As Long = &H8&
Public Const E_NOINTERFACE As Long = &H80004002

Public Const MF_STARTUP_FULL As Long = &H0&
Public Const MF_VERSION As Long = &H1&

Public Const IID_IMFSinkWriterCallback As String = "{666f76de-33d2-41b9-a458-29ed0a972c58}"

Public Const MF_SINK_WRITER_ALL_STREAMS As Long = &HFFFFFFFE
Public Const MF_SINK_WRITER_ASYNC_CALLBACK As String = "{48cb183e-7b0b-46f4-822e-5e1d2dda4354}"
Public Const MF_SINK_WRITER_DISABLE_THROTTLING As String = "{08b845d8-2b74-4afe-9d53-be16d2d5ae4f}"

Public Const MF_READWRITE_ENABLE_HARDWARE_TRANSFORMS As String = "{a634a91c-822b-41b9-a494-4de4643612b0}"

Public Const MF_TRANSCODE_CONTAINERTYPE As String = "{150ff23f-4abc-478b-ac4f-e1916fba1cca}"

Public Const MF_MT_MAJOR_TYPE As String = "{48eba18e-f8c9-4687-bf11-0a74c9f96a8f}"
Public Const MF_MT_SUBTYPE As String = "{f7e34c9a-42e8-4714-b74b-cb29d72c35e5}"
Public Const MF_MT_AUDIO_SAMPLES_PER_SECOND As String = "{5faeeae7-0290-4c31-9e8a-c534f68d9dba}"
Public Const MF_MT_AUDIO_BITS_PER_SAMPLE As String = "{f2deb57f-40fa-4764-aa33-ed4f2d1ff669}"
Public Const MF_MT_AUDIO_NUM_CHANNELS As String = "{37e48bf5-645e-4c5b-89de-ada9e29b696a}"
Public Const MF_MT_AUDIO_AVG_BYTES_PER_SECOND As String = "{1aab75c8-cfef-451c-ab95-ac034b8e1731}"
Public Const MF_MT_AUDIO_BLOCK_ALIGNMENT As String = "{322de230-9eeb-43bd-ab7a-ff412251541d}"

Public Const MFMediaType_Audio As String = "{73647561-0000-0010-8000-00aa00389b71}"
Public Const MFAudioFormat_Float As String = "{00000003-0000-0010-8000-00aa00389b71}"
Public Const MFAudioFormat_MP3 As String = "{00000055-0000-0010-8000-00aa00389b71}"
Public Const MFTranscodeContainerType_MP3 As String = "{e438b912-83f1-4de6-9e3a-9ffbc6dd24d1}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    'IUnknown
    QueryInterface = 0
    
    'IMFSinkWriter
    AddStream = 3
    SetInputMediaType = 4
    BeginWriting = 5
    WriteSample = 6
    Flush = 10
    Finalize = 11

    'IMFMediaType / IMFAttributes
    SetUINT32 = 21
    SetGUID = 24
    SetUnknown = 27
    
    'IMFMediaBuffer
    Lock_Buffer = 3
    Unlock_Buffer = 4
    SetCurrentLength = 6
    
    'IMFSample
    AddBuffer = 42

End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type tIMFSinkWriterCallback
    pVTable As Long
End Type

Public Type tIMFSinkWriterCallbackVTable
    VTable(0 To 4) As Long
End Type

' ----==== Kernel32.dll Deklarationen ====----
Public Declare Sub Sleep Lib "kernel32.dll" ( _
                   ByVal lngMilliseconds As Long)

Public Declare Sub CopyMemory Lib "kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)

Public Declare Function lstrlenW Lib "kernel32.dll" ( _
                        ByVal lpString As Long) As Long

' ----==== Ole32 API-Deklarationen ====----
Public Declare Function CLSIDFromString Lib "ole32.dll" ( _
                        ByVal pString As Long, _
                        ByRef pCLSID As GUID) As Long

Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal hMem As Long)
                    
Public Declare Function StringFromIID Lib "ole32.dll" ( _
                        ByRef pCLSID As GUID, _
                        ByRef lpszProgID As Long) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Public Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                        ByVal pvInstance As Long, _
                        ByVal oVft As Long, _
                        ByVal cc As Long, _
                        ByVal vtReturn As VbVarType, _
                        ByVal cActuals As Long, _
                        ByVal prgvt As Any, _
                        ByVal prgpvarg As Any, _
                        ByRef pvargResult As Variant) As Long

' ----==== Mfplat.dll Deklarationen ====----
Public Declare Function MFStartup Lib "Mfplat.dll" ( _
                        ByVal Version As Long, _
                        ByVal dwFlags As Long) As Long

Public Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Public Declare Function MFCreateMediaType Lib "Mfplat.dll" ( _
                        ByRef ppMFType As Long) As Long

Public Declare Function MFCreateAttributes Lib "Mfplat.dll" ( _
                        ByRef ppMFAttributes As Long, _
                        ByVal cInitialSize As Long) As Long

Public Declare Function MFCreateSample Lib "Mfplat.dll" ( _
                        ByRef ppIMFSample As Long) As Long

Public Declare Function MFCreateMemoryBuffer Lib "Mfplat.dll" ( _
                        ByVal cbMaxLength As Long, _
                        ByRef ppBuffer As Long) As Long

' ----==== Mfreadwrite.dll Deklarationen ====----
Public Declare Function MFCreateSinkWriterFromURL Lib "Mfreadwrite.dll" ( _
                        ByVal pwszOutputURL As Long, _
                        ByVal pByteStream As Long, _
                        ByVal pAttributes As Long, _
                        ByRef ppSinkWriter As Long) As Long

' ----==== Variablen ====----
Private m_RefCount As Long
Private m_pIMFSinkWriterCallback As Long
Private m_IMFSinkWriterCallback As tIMFSinkWriterCallback
Private m_IMFSinkWriterCallbackVTable As tIMFSinkWriterCallbackVTable

Public Function pIMFSinkWriterCallback() As Long

    ' ----==== Interface IMFSinkWriterCallback  ====----
    With m_IMFSinkWriterCallbackVTable
        ' VTable aufbauen
        .VTable(0) = ProcPtr(AddressOf QueryInterface_)
        .VTable(1) = ProcPtr(AddressOf AddRef_)
        .VTable(2) = ProcPtr(AddressOf Release_)
        .VTable(3) = ProcPtr(AddressOf OnFinalize_)
        .VTable(4) = ProcPtr(AddressOf OnMarker_)
    End With

    With m_IMFSinkWriterCallback
        ' Pointer auf die VTable
        .pVTable = VarPtr(m_IMFSinkWriterCallbackVTable)
    End With
    
    m_pIMFSinkWriterCallback = VarPtr(m_IMFSinkWriterCallback)
    
    ' Pointer auf das Interface
    pIMFSinkWriterCallback = m_pIMFSinkWriterCallback

End Function

' ----==== Hilfsfunktion ====----
Private Function ProcPtr(ByVal ptr As Long) As Long

    ProcPtr = ptr

End Function

' ----==== Interface IUnknown QueryInterface ====----
Private Function QueryInterface_(ByVal this As Long, ByRef riid As GUID, ByRef _
    pvObj As Long) As Long

    Dim lRet As Long
    
    Select Case UCase$(Guid2Str(riid))

    ' wenn nach dem Interface IMFSinkWriterCallback gefragt wird
    Case UCase$(IID_IMFSinkWriterCallback)

        ' dann muss ein AddRef aufgerufen werden.
        Call AddRef_(this)
        
        ' Pointer auf das Interface
        pvObj = m_pIMFSinkWriterCallback
        
        ' OK zurck geben, Interface ist vorhanden
        lRet = S_OK

    Case Else
        
        ' alles andere ignorieren
        
        pvObj = 0&
        
        lRet = E_NOINTERFACE
    
    End Select

    QueryInterface_ = lRet

End Function

' ----==== Interface IUnknown AddRef ====----
Private Function AddRef_(ByVal this As Long) As Long

    m_RefCount = m_RefCount + 1

    AddRef_ = m_RefCount

End Function

' ----==== Interface IUnknown Release ====----
Private Function Release_(ByVal this As Long) As Long

    m_RefCount = m_RefCount - 1
   
    Release_ = m_RefCount

End Function

' ----==== Interface IMFSinkWriterCallback Funktionen ====----
Private Function OnFinalize_(ByVal this As Long, _
    ByVal hrStatus As Long) As Long
    'do not use
End Function

Private Function OnMarker_(ByVal this As Long, _
    ByVal dwStreamIndex As Long, _
    ByVal pvContext As Long) As Long
    'do not use
End Function

' ----==== Erstellt ein IMFSinkWriter fr MP3, ein IMFSample und ein IMFMediaBuffer ====----
Public Function CreateWriter(ByVal sFileName As String, ByRef pWriter As Long, _
    ByRef lStreamIndex As Long, ByRef pSample As Long, ByRef pBuffer As Long, _
    ByVal lMaxBufferSize As Long) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    ' SinkWriter fr MP3 erstellen
    If CreateSinkWriter(sFileName, pWriter, lStreamIndex) = True Then
    
        ' ein IMFSample erstellen
        If MFCreateSample(pSample) = S_OK Then
            
            ' ein IMFMediaBuffer erstellen
            If MFCreateMemoryBuffer(lMaxBufferSize, pBuffer) = S_OK Then
                    
                ' IMFMediaBuffer dem IMFSample hinzufgen
                If Invoke(pSample, AddBuffer, pBuffer) = S_OK Then
                    
                    ' mit dem schreiben in den IMFSinkWriter beginnen
                    If Invoke(pWriter, BeginWriting) = S_OK Then
                    
                        bolRet = True
                        
                    End If
                    
                End If
                
            End If
            
        End If
    
    End If
    
    CreateWriter = bolRet
    
End Function

' ----==== PCM-Daten in den SinkWriter schreiben ====----
Public Function WriteSampleData(ByVal pWriter As Long, ByVal pSample As Long, _
    ByVal pBuffer As Long, ByVal lStreamIndex As Long, _
    ByRef aPcmData() As Byte) As Boolean

    Dim bolRet As Boolean
    Dim pLockBuffer As Long
    Dim lngMaxLength As Long
    Dim lngCurLength As Long
    Dim aFloatData() As Byte

    bolRet = False
    
    ' PCM zu Float konvertieren
    Call Pcm2Float(aPcmData, aFloatData)
    
    ' Gre des Buffer festlegen
    If Invoke(pBuffer, SetCurrentLength, UBound(aFloatData) + 1) = S_OK Then

        ' Pointer auf die IMFMediaBuffer Daten ermitteln
        If Invoke(pBuffer, Lock_Buffer, VarPtr(pLockBuffer), VarPtr(lngMaxLength), VarPtr(lngCurLength)) = S_OK Then

            ' Daten in den IMFMediaBuffer kopieren
            Call CopyMemory(ByVal pLockBuffer, aFloatData(0), lngCurLength)

            ' Lock aufheben
            If Invoke(pBuffer, Unlock_Buffer) = S_OK Then

                ' der IMFSinkWriter schreibt das IMFSample als MP3 raus
                If Invoke(pWriter, WriteSample, lStreamIndex, pSample) = S_OK Then

                    ' etwas Zeit geben damit die vorhergehende
                    ' Anweisung abgearbeitet werden kann.
                    Call Delay(0.01)

                    bolRet = True

                End If
                    
            End If

        End If

    End If

    WriteSampleData = bolRet

End Function

' ----==== Schreiben in den IMFSinkWriter abschlieen ====----
Public Function CloseWriter(ByVal pWriter As Long, ByVal pSample As Long, _
    ByVal pBuffer As Long) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    ' restliche Daten schreiben falls noch welche vorhanden
    If Invoke(pWriter, Flush, MF_SINK_WRITER_ALL_STREAMS) = S_OK Then
    
        ' etwas Zeit geben damit die vorhergehende
        ' Anweisung abgearbeitet werden kann
        Call Delay(0.05)
        
        ' Schreiben abschlieen
        If Invoke(pWriter, Finalize) = S_OK Then
        
            ' etwas Zeit geben damit die vorhergehende
            ' Anweisung abgearbeitet werden kann
            Call Delay(0.05)
            
            ' freigeben
            Call Release(pBuffer)
                
            ' freigeben
            Call Release(pSample)
            
            ' freigeben
            Call Release(pWriter)
        
            bolRet = True
            
        End If
        
    End If
    
    CloseWriter = bolRet
    
End Function

' ----==== SinkWriter erstellen ====----
Private Function CreateSinkWriter(ByVal sURL As String, ByRef pWriter As Long, _
    ByRef lStreamIndex As Long) As Boolean

    Dim bolRet As Boolean
    Dim pAttributes As Long
    Dim pMediaTypeIn As Long
    Dim pMediaTypeOut As Long

    bolRet = False
    
    ' IMFAttributes-Interface erstellen
    If MFCreateAttributes(pAttributes, 0&) = S_OK Then
    
        ' Containertyp festlegen
        If Invoke(pAttributes, SetGUID, _
            VarPtr(Str2Guid(MF_TRANSCODE_CONTAINERTYPE)), _
            VarPtr(Str2Guid(MFTranscodeContainerType_MP3))) = S_OK Then
    
            ' IMFSinkWriterCallback festlegen
            ' (Optional) Sollte aber angegeben werden da sonst
            ' IMFSinkWriter.Finalize den Thread blockiert.
            If Invoke(pAttributes, SetUnknown, _
                VarPtr(Str2Guid(MF_SINK_WRITER_ASYNC_CALLBACK)), _
                pIMFSinkWriterCallback) = S_OK Then
                
                ' Thread Blockierung fr IMFSinkWriter.WriteSample
                ' abschalten (Optional)
                If Invoke(pAttributes, SetUINT32, _
                    VarPtr(Str2Guid(MF_SINK_WRITER_DISABLE_THROTTLING)), _
                    CLng(1)) = S_OK Then

                    ' Verwendung Hardwarebasierter MFTs aktivieren (Optional)
                    If Invoke(pAttributes, SetUINT32, _
                        VarPtr(Str2Guid(MF_READWRITE_ENABLE_HARDWARE_TRANSFORMS)), _
                        CLng(1)) = S_OK Then
                    
                        ' SinkWriter erstellen
                        If MFCreateSinkWriterFromURL(StrPtr(sURL), 0&, pAttributes, pWriter) = S_OK Then

                            ' OutputType fr den SinkWriter erstellen
                            If CreateOutputType(pMediaTypeOut) = True Then

                                ' OutputType fr den SinkWriter festlegen
                                If Invoke(pWriter, AddStream, pMediaTypeOut, _
                                    VarPtr(lStreamIndex)) = S_OK Then

                                    ' InputType fr den SinkWriter erstellen
                                    If CreateInputTypeFloat(pMediaTypeIn) = True Then

                                        ' InputType fr den SinkWriter festlegen
                                        If Invoke(pWriter, SetInputMediaType, lStreamIndex, _
                                            pMediaTypeIn, 0&) = S_OK Then

                                            bolRet = True

                                        End If

                                        ' freigeben
                                        Call Release(pMediaTypeIn)

                                    End If

                                End If

                                ' freigeben
                                Call Release(pMediaTypeOut)
                            
                            End If

                        End If
                    
                    End If
    
                End If
        
            End If
        
        End If

        ' freigeben
        Call Release(pAttributes)
    
    End If

    CreateSinkWriter = bolRet

End Function

' ----==== InputType fr den SinkWriter ====----
Private Function CreateInputTypeFloat(ByRef pType As Long) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    ' MediaType erstellen
    If MFCreateMediaType(pType) = S_OK Then
        
        ' MajorType Audio
        If Invoke(pType, SetGUID, VarPtr(Str2Guid(MF_MT_MAJOR_TYPE)), _
            VarPtr(Str2Guid(MFMediaType_Audio))) = S_OK Then
            
            ' SubType Float
            If Invoke(pType, SetGUID, VarPtr(Str2Guid(MF_MT_SUBTYPE)), _
                VarPtr(Str2Guid(MFAudioFormat_Float))) = S_OK Then
                        
                ' 44.1kHz
                If Invoke(pType, SetUINT32, _
                    VarPtr(Str2Guid(MF_MT_AUDIO_SAMPLES_PER_SECOND)), _
                    CLng(44100)) = S_OK Then
                    
                    ' 32bit
                    If Invoke(pType, SetUINT32, _
                        VarPtr(Str2Guid(MF_MT_AUDIO_BITS_PER_SAMPLE)), _
                        CLng(32)) = S_OK Then

                        ' 2Ch
                        If Invoke(pType, SetUINT32, _
                            VarPtr(Str2Guid(MF_MT_AUDIO_NUM_CHANNELS)), _
                            CLng(2)) = S_OK Then
                            
                            ' 352.8kb/s
                            If Invoke(pType, SetUINT32, _
                                VarPtr(Str2Guid(MF_MT_AUDIO_AVG_BYTES_PER_SECOND)), _
                                CLng(352800)) = S_OK Then

                                If Invoke(pType, SetUINT32, _
                                    VarPtr(Str2Guid(MF_MT_AUDIO_BLOCK_ALIGNMENT)), _
                                    CLng(8)) = S_OK Then
                            
                                    bolRet = True
                        
                                End If

                            End If
                        
                        End If
                        
                    End If
                    
                End If
                        
            End If
                
        End If
        
    End If

    CreateInputTypeFloat = bolRet
    
End Function

' ----==== OutputType fr den SinkWriter ====----
Private Function CreateOutputType(ByRef pOutputType As Long) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    ' MediaType erstellen
    If MFCreateMediaType(pOutputType) = S_OK Then

        ' MajorType setzen
        If Invoke(pOutputType, SetGUID, _
            VarPtr(Str2Guid(MF_MT_MAJOR_TYPE)), _
            VarPtr(Str2Guid(MFMediaType_Audio))) = S_OK Then

            ' SubType MP3
            If Invoke(pOutputType, SetGUID, _
                VarPtr(Str2Guid(MF_MT_SUBTYPE)), _
                VarPtr(Str2Guid(MFAudioFormat_MP3))) = S_OK Then

                ' 44.1kHz
                If Invoke(pOutputType, SetUINT32, _
                    VarPtr(Str2Guid(MF_MT_AUDIO_SAMPLES_PER_SECOND)), _
                    CLng(44100)) = S_OK Then
                    
                    ' 2Ch
                    If Invoke(pOutputType, SetUINT32, _
                        VarPtr(Str2Guid(MF_MT_AUDIO_NUM_CHANNELS)), _
                        CLng(2)) = S_OK Then
                    
                        ' 320kb/s
                        If Invoke(pOutputType, SetUINT32, _
                            VarPtr(Str2Guid(MF_MT_AUDIO_AVG_BYTES_PER_SECOND)), _
                            CLng(32000)) = S_OK Then
                                        
                            bolRet = True
                    
                        End If
                        
                    End If
            
                End If
                
            End If
        
        End If
        
    End If
    
    CreateOutputType = bolRet
    
End Function

' ----==== PCM -> FLOAT ====----
Private Sub Pcm2Float(ByRef aPCM() As Byte, ByRef aFloat() As Byte)

    Dim lngItem As Long
    Dim lngCount As Long
    Dim intData As Integer
    Dim sngData As Single

    ' Gre des PCM Arrays
    lngCount = UBound(aPCM) + 1
    
    ' Gre des PCM Arrays mal 2
    ReDim aFloat((lngCount * 2) - 1)
    
    ' Daten im PCM Array durchlaufen
    For lngItem = 0 To lngCount - 1 Step 2
    
        ' 2 Byte vom PCM Array -> Signed-Integer
        Call CopyMemory(intData, aPCM(lngItem), 2)
        
        ' Signed-Integer -> Float
        sngData = CSng(CSng(intData) / CSng(32767))
        
        ' Begrenzung
        If sngData > CSng(1) Then sngData = CSng(1)
        If sngData < CSng(-1) Then sngData = CSng(-1)
        
        ' Float zurck kopieren
        Call CopyMemory(aFloat(lngItem * 2), sngData, 4)
    
    Next lngItem

End Sub

' ----==== ruft die Funktion OleInvoke auf ====----
Public Function Invoke(ByVal pInterface As Long, _
    ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== fhrt die Interface Funktionen aus ====----
Private Function OleInvoke(ByVal pInterface As Long, _
    ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lItem As Long
    Dim lCount As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== String -> GUID ====----
Public Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function

' ----==== GUID -> String ====----
Public Function Guid2Str(ByRef tGUID As GUID) As String

    Dim pStr As Long
    Dim strRet As String

    If StringFromIID(tGUID, pStr) = S_OK Then

        strRet = Ptr2Str(pStr)
    
    End If

    Guid2Str = strRet

End Function

' ----==== Pointer -> String ====----
Public Function Ptr2Str(ByVal pStr As Long) As String

    Dim lngLen As Long
    Dim strRet As String
    Dim bytBuffer() As Byte

    If pStr = 0 Then Exit Function

    lngLen = lstrlenW(pStr) * 2& - 1&

    If lngLen > 0& Then

        ReDim bytBuffer(lngLen)

        Call CopyMemory(bytBuffer(0), ByVal pStr, lngLen)
        
        Call CoTaskMemFree(pStr)

        strRet = bytBuffer

    End If
    
    Ptr2Str = strRet

End Function

' ----==== Delay ====----
Public Sub Delay(ByVal SecsDelay As Single)

    Dim TimeOut   As Single
    Dim PrevTimer As Single

    PrevTimer = Timer
    TimeOut = PrevTimer + SecsDelay

    Do While PrevTimer < TimeOut

        Call Sleep(1)

        DoEvents

        If Timer < PrevTimer Then TimeOut = TimeOut - 86400

        PrevTimer = Timer

    Loop

End Sub

